unit Magvari3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Menus, StdCtrls, Mask;

type
  TForm3 = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Image1: TImage;
    Exit1: TMenuItem;
    procedure ChgDateFmt;
    procedure Exit1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form3: TForm3;
  Anno, Mese, Giorno: Word;
  FileModel: String;
  MPartsUp, MPartsDn, DLat, LonLeft, LatUp, DLon: Real;

const
  crNorth = 1;

implementation

{$R *.DFM}
{$R LBKCUR.RES}

uses MagVari1;

Function MagVarC(PDate: XDate; Lat, Lon, Alt: Real; FileModel: XFile): Param;
  far; external 'MagVar.DLL';

function MParts(E1: Real): Real;
begin
  Result := E1 * 60;
end;

function MLati(E1: Real): Real;
begin
  result := E1 / 60;
end;

procedure TForm3.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm3.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  Lat, Lon: Real;
  EorW: String[2];
  NorS: String[2];
  VEorW: String[2];
begin
  {Compute mouse pointer position}

  Lat := Y * DLat / Image1.Height;
  Lat := MPartsUp - Lat;
  Lat := MLati(Lat);

  Lon := X * DLon / Image1.Width;
  Lon := Lon + LonLeft;

  {call DLL}

  ToBePassed := MagVarC(ForTheDate, Lat, Lon,
    StrToFloat(Form1.MaskEdit7.Text), FileModelNull);

  if ToBePassed.OK = '1' then begin
    MessageDlg(ErrorMessage2, mtError, [mbOK], 0);
    Form3.Close;
  end;

  if ToBePassed.OK > '1' then begin
    MessageDlg(ErrorMessage3, mtError, [mbOK], 0);
    Form3.Close;
  end;

  if ToBePassed.OK = '0' then begin

    if Lon < 0 then EorW := ' W' else EorW := ' E';
    if Lat < 0 then NorS := ' S' else NorS := ' N';
    if ToBePassed.Variation < 0 then VEorW := ' W' else VEorW := ' E';

    Panel1.Caption := 'Lat. ' +
                      FloatToStrf(Abs(Lat), ffNumber, 18, 0) + ' ' +
                      FloatToStrf(Abs((Lat - Int(Lat)) * 60), ffNumber, 18, 3) +
                      '''' + NorS + '    Lon. ' +
                      FloatToStrf(Abs(Lon), ffnumber, 18, 0) + ' ' +
                      FloatToStrf(Abs((Lon - Int(Lon)) * 60), ffNumber, 18, 3) +
                      '''' + EorW + '    Var. ' +
                      FloatToStrf(Abs(ToBePassed.Variation), ffNumber, 18, 1) +
                      ' ' + VEorW;
  end;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  SCreen.Cursors[crNorth] := LoadCursor(HInstance, 'LBKCUR');
  Form3.Cursor := crNorth;
  ChgDateFmt;
  LatUp := 85;
  MPartsUp := MParts(85);
  MPartsDn := MParts(-85);
  DLat := MPartsUp - MPartsDn;
  LonLeft := -180;
  DLon := 360;
end;

procedure TForm3.FormActivate(Sender: TObject);
begin
  FileModel := ExtractFilePath(ParamStr(0)) +
    Form1.ComboBox1.Text + Form1.MaskEdit1.Text + '.MD';
  StrPCopy(FileModelNull, FileModel);
  StrPCopy(ForTheDate, Form1.MaskEdit2.Text);
end;

procedure TForm3.ChgDateFmt; {Force year to 4 digits in date format}
var
  S: String[15];
begin
  S := ShortDateFormat;

  {Convert to  right case if needed}
  while Pos('Y', S) > 0 do
    S[Pos('Y', S)] := 'y';

  while Pos('m', S) > 0 do
    S[Pos('m', S)] := 'M';

  while Pos('D', S) > 0 do
    S[Pos('D', S)] := 'd';

  {if error then exit}
  if Pos('y', S) = 0 then exit;
  if pos('M', S) = 0 then exit;
  if Pos('d', S) = 0 then exit;

  {insert until 4 * y}
  while Pos('yyyy', S) = 0 do
  Insert('y', S, Pos('y', S));

  {insert until 2 * M}
  while Pos('MM', S) = 0 do
  Insert('M', S, Pos('M', S));

  {insert until 2 * d}
  while Pos('dd', S) = 0 do
  Insert('d', S, Pos('d', S));

  ShortDateFormat := S;
end;

end.
